class NeMapPlugin {
  apply(compiler) {
    compiler.plugin('emit', function(compilation, callback) {
      let srcStr = '';
      let source = compilation.assets['index.html'].source();
      const depObj = {
        AMap: false,
        BMap: false,
        TMap: false,
      };
      // 获取webpack生成的依赖
      for (const item of compilation.fileDependencies) {
        if (item.indexOf('AMap.js') > -1 && !depObj.AMap) {
          depObj.AMap = true;
        }
        if (item.indexOf('BMap.js') > -1 && !depObj.BMap) {
          depObj.BMap = true;
        }
        if (item.indexOf('TMap.js') > -1 && !depObj.TMap) {
          depObj.TMap = true;
        }
      }
      // 准备需要添加的script标签
      if (depObj.TMap) {
        const src1 = '//map.qq.com/api/js?v=2.exp&key=' + process.env.NEMAP_TKEY + '&libraries=drawing,geometry,autocomplete,convertor';
        const src2 = '//open.map.qq.com/apifiles/plugins/heatmap/heatmap.min.js';
        srcStr += `<script src="${src1}"></script>\n`;
        srcStr += `<script src="${src2}"></script>\n`;
      }
      if (depObj.AMap) {
        const src1 = '//webapi.amap.com/maps?v=1.4.7&key=' + (process.env.NEMAP_AKEY || '1f2446ffc55c248c397a7e2afe2470b0');
        const src2 = '//webapi.amap.com/ui/1.0/main.js?v=1.0.11';
        srcStr += `<script src="${src1}"></script>\n`;
        srcStr += `<script src="${src2}"></script>\n`;
      }
      if (depObj.BMap) {
        const src1 = '//api.map.baidu.com/api?v=2.0&ak=' + (process.env.NEMAP_BKEY || 'GWobIGx2NKsjtGSDaGXRdT85ZunIZ7bC');
        const src2 = '//api.map.baidu.com/library/LuShu/1.2/src/LuShu_min.js';
        const src3 = '//api.map.baidu.com/library/Heatmap/2.0/src/Heatmap_min.js';
        srcStr += `<script src="${src1}"></script>\n`;
        srcStr += `<script src="${src2}"></script>\n`;
        srcStr += `<script src="${src3}"></script>\n`;
      }
      source = source.replace(/<body>/, '<body>\n' + srcStr);
      // 重写工厂函数
      compilation.assets['index.html'].source = function() {
        return source;
      };
      callback();
    });
  }
}

module.exports = NeMapPlugin;
